/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Software
 * 
 *  Copyright (C) 2012-2013 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: gpos_app.c 427 2013-03-05 08:33:45Z ertl-honda $
 */

#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <unistd.h>
#include "dualoscom.h"

bool
filter_even(void *buffer, uint32_t size)
{
	uint32_t value;

	value = *((uint32_t *)buffer);

	if ((value % 2) == 0)  return true;
	return false;
}

#define SHMEM_SIZE 64

void
share_mem_test() {
	int ret;
	void *buffer;
	uint32_t size;
	int data;
	int i;

	printf("Share mem test start!.\n");
	fflush(stdout);

	ret = dualoscom_shmem_get(DUALOSCOM_SHMEM_1, &buffer, &size);
	if(ret != 0) {
		printf("Get Buffer Error!! %d\n",ret);
		fflush(stdout);
	}

	printf("buffer 0x%x, Size %d.\n", (unsigned int)buffer, size);
	fflush(stdout);

	data = 0;
	while(1) {
		for(i = 0; i < SHMEM_SIZE/8; i++){
			printf("%d : %d, ", i, *((uint32_t *)buffer + i));
		}
		printf("\n");
		sleep(2);
	}
}

int main()
{
	int ret;
	void *buffer;
	uint32_t size;
	dualoscom_block_id_t block_id;
	char msg[] = "hey!";

	printf("GPOS dualoscom_init\n");
	ret = dualoscom_init(true, 0);
	assert(ret == 0);

	printf("Dual-OS communications initialized\n");


	/* phase 1 */
	printf("GPOS wait for message\n");
	ret = dualoscom_channel_event_wait(DUALOSCOM_CHANNEL_0, 0);
	assert(ret == 0);

	printf("Event received\n");

	ret = dualoscom_channel_block_dequeue(DUALOSCOM_CHANNEL_0, &block_id);
	printf("dualoscom_block_dequeue() %d\n", ret);
	assert(ret == 0);

	ret = dualoscom_channel_block_getbuffer(DUALOSCOM_CHANNEL_0, block_id, &buffer, &size);
	assert(ret == 0);

	printf("MSG: %s\n", (char *)buffer);

	printf("GPOS send ack\n");
	ret = dualoscom_channel_event_send(DUALOSCOM_CHANNEL_0);
	assert(ret == 0);

	/* phase 2 */
	printf("GPOS wait for rpc\n");
	ret = dualoscom_channel_event_wait(DUALOSCOM_CHANNEL_0, 0);
	assert(ret == 0);

	printf("received params: %u and %u\n",
		   *((uint32_t *)buffer), *((uint32_t *)(buffer + 4)));

	*((uint32_t *)buffer) = *((uint32_t *)buffer) * *((uint32_t *)(buffer + 4));
	printf("GPOS send rpc result (%u)\n", *((uint32_t *)buffer));

	ret = dualoscom_channel_event_send(DUALOSCOM_CHANNEL_0);
	assert(ret == 0);


	/* phase 3 */
	printf("GPOS wait for rpc\n");
	ret = dualoscom_channel_event_wait(DUALOSCOM_CHANNEL_0, 0);
	assert(ret == 0);

	printf("received params: %u and %u\n",
		   *((uint32_t *)buffer), *((uint32_t *)(buffer + 4)));

	*((uint32_t *)buffer) = *((uint32_t *)buffer) * *((uint32_t *)(buffer + 4));
	printf("GPOS send rpc result (%u)\n", *((uint32_t *)buffer));

	ret = dualoscom_channel_event_send(DUALOSCOM_CHANNEL_0);
	assert(ret == 0);

	printf("GPOS dualoscom_channel_block_free\n");
	ret = dualoscom_channel_block_free(DUALOSCOM_CHANNEL_0, block_id);
	assert(ret == 0);


	/* phase 4 */
	printf("Send a message to the RTOS by channel 1\n");
	ret = dualoscom_channel_block_alloc(DUALOSCOM_CHANNEL_1, &block_id);
	assert(ret == 0);

	ret = dualoscom_channel_block_getbuffer(DUALOSCOM_CHANNEL_1, block_id, &buffer, &size);
	assert(ret == 0);

	assert(sizeof(msg) < size);
	memcpy(buffer, (void *)msg, sizeof(msg));

	ret = dualoscom_channel_block_enqueue(DUALOSCOM_CHANNEL_1, block_id);
	assert(ret == 0);

	ret = dualoscom_channel_event_send(DUALOSCOM_CHANNEL_1);
	assert(ret == 0);


	/* phase 5 */
	printf("Send several messages with a filter on\n");

	ret = dualoscom_channel_block_alloc(DUALOSCOM_CHANNEL_0, &block_id);
	assert(ret == 0);

	ret = dualoscom_channel_block_getbuffer(DUALOSCOM_CHANNEL_0, block_id, &buffer, &size);
	assert(ret == 0);

	*((uint32_t *)buffer) = 1;

	ret = dualoscom_channel_block_enqueue(DUALOSCOM_CHANNEL_0, block_id);
	if(ret != 0) printf("data %u filtered\n",*((uint32_t *)buffer));

	ret = dualoscom_channel_block_alloc(DUALOSCOM_CHANNEL_0, &block_id);
	assert(ret == 0);

	ret = dualoscom_channel_block_getbuffer(DUALOSCOM_CHANNEL_0, block_id, &buffer, &size);
	assert(ret == 0);

	*((uint32_t *)buffer) = 2;

	ret = dualoscom_channel_block_enqueue(DUALOSCOM_CHANNEL_0, block_id);
	if(ret != 0) printf("data %u filtered\n",*((uint32_t *)buffer));

	ret = dualoscom_channel_block_alloc(DUALOSCOM_CHANNEL_0, &block_id);
	assert(ret == 0);

	ret = dualoscom_channel_block_getbuffer(DUALOSCOM_CHANNEL_0, block_id, &buffer, &size);
	assert(ret == 0);

	*((uint32_t *)buffer) = 3;

	ret = dualoscom_channel_block_enqueue(DUALOSCOM_CHANNEL_0, block_id);
	if(ret != 0) printf("data %u filtered\n",*((uint32_t *)buffer));

	ret = dualoscom_channel_event_send(DUALOSCOM_CHANNEL_0);
	assert(ret == 0);

	share_mem_test();

	return 0;
}
