/*
 *  TOPPERS/SafeG Dual-OS monitor
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Safety Gate Dual-OS monitor
 *
 *  Copyright (C) 2012-2013 by Embedded and Real-Time Systems Laboratory
 *     Graduate School of Information Science, Nagoya University, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id: dualoscom_kernel.h 428 2013-03-05 08:38:58Z ertl-honda $
 */

#ifndef DUALOSCOM_KERNEL_H
#define DUALOSCOM_KERNEL_H

#include <kernel.h>
#include <t_syslog.h>
#include <t_stddef.h> /* uint32_t, bool_t */
#include "t_os-dualoscom_config.h"

#define DUALOSCOM_T

#define COPY_UPDATE_ALGORITHM_ENABLE

#define DEBUG(enable,x,args...) \
    if(enable) syslog(LOG_NOTICE, "DEBUG (%s): " x, __func__ , ##args);

#define PRINT(x, args...) \
    syslog(LOG_NOTICE, x, ##args);

/*
 * KERNEL INTERFACE
 */
extern int __dualoscom_kernel_init(dualoscom_time_t timeout, void *shregion);
extern int __dualoscom_kernel_shregion_init(void **shregion);
extern int __dualoscom_kernel_sendevent(dualoscom_channel_id_t channel_id);
extern int __dualoscom_kernel_waitevent(dualoscom_channel_id_t channel_id, dualoscom_time_t timeout);
extern int __dualoscom_kernel_waitgroup(dualoscom_group_id_t group_id, dualoscom_time_t timeout);

static inline bool_t
__dualoscom_kernel_check_tskctx()
{
    if (sns_ctx() || sns_dsp() || sns_loc()) {
       return false;
    }
    return true;
} 

static inline void
__dualoscom_kernel_lock()
{
    if(sns_ctx()) {
        iloc_cpu();
    }
    else {
        loc_cpu();
    }
}

static inline void
__dualoscom_kernel_unlock()
{
    if(sns_ctx()) {
        iunl_cpu();
    }
    else {
        unl_cpu();
    }    
}

#endif /* DUALOSCOM_KERNEL_H */
