#include <asm/hardware/gic.h>  /* for safeg_raise_softfiq */

//#define ALLOC_DEVICE_MANUALLY

/*
 * ARCHITECTURE
 */
#define __TARGET_ARCH_ARM 7

/*
 * SHARED MEMORY (allocated in kernel parameters)
 */
#define SHREGION_PHYS_ADDRESS    0x5FC00000UL
#define SHREGION_SIZE            0x00400000UL /* 4MB */

#define DUALOSCOM_T2NT_IRQ  (106+32)
#define DUALOSCOM_NT2T_IRQ  (107+32)

#define NT_SMC_WRITE_REG  5

static void
send_nt2t_irq(){
    unsigned int val = 0x800;
    unsigned int phy_add = 0xC2800210;
    
    __asm__ volatile("mov r0, %0\n\t"
        "mov r1, %1\n\t"
        "mov r2, %2\n\t"
        "smc 0\n\t"
        : /* no output */
        : "I" (NT_SMC_WRITE_REG), "r" (val), "r" (phy_add)
        : "r0", "r1", "r2", "memory");
}

/*
 * MAX VALUES (can be adjusted)
 */
#define MAX_NUM_CHANNELS   1024
#define MAX_NUM_GROUPS     64
#define MAX_PENDING_OFFSET (SHREGION_SIZE - MAX_NUM_CHANNELS*8)
