rm -R -f build
mkdir -p build
cd build
echo ">> building hermit"
tar xvfz ../src/hermit-at-3.1.0-source.tar.gz
cd hermit-at-3.1.0
patch -p1 < ../../../../patch/hermit/1_NS_hermit-at-3.1.0_basic.patch
make armadillo800eva_mmcsd_defconfig
make
cd ..
echo ">> building Linux kernel"
tar xvfz ../src/linux-2.6.35-a800eva-at3.tar.gz
cd linux-2.6.35-a800eva-at3
patch -p1 < ../../../../patch/Linux/1_NS_linux-2.6.35-a800eva-at3_basic.patch
patch -p1 < ../../../../patch/Linux/3_NS_linux-2.6.35-a800eva-at3_com.patch
cd safeg
cp ../../../../../com/src/linux-driver/* .
cp ../../../../../com/src/target/armadillo-800-eva_nt_linux/* .
cd ..
make ARCH=arm armadillo800eva_android_defconfig
make ARCH=arm CROSS_COMPILE=arm-linux-gnueabi-
cd ../../
#pwd
echo ">> building ASP kernel"
tar xvfz ./src/asp_armadillo-800-eva_gcc-20130221.tar.gz -C ../..
tar xvfz ./src/cfg-1.8.0.tar.gz -C ../../asp
cd ../../asp/cfg
./configure
make
cd ../../app/sample1_s/
make depend
make
echo ">> building SafeG"
cd ../../safeg
make
cd ../
echo ">> copying binary files"
mkdir ./tools/auto_build/output
cp ./app/sample1_s/asp.elf ./tools/auto_build/output
cp ./tools/auto_build/build/hermit-at-3.1.0/src/target/armadillo8x0/loader-armadillo800eva-mmcsd-v3.1.0.elf ./tools/auto_build/output
cp ./tools/auto_build/build/linux-2.6.35-a800eva-at3/arch/arm/boot/Image ./tools/auto_build/output
cp ./tools/auto_build/build/linux-2.6.35-a800eva-at3/arch/arm/boot/zImage ./tools/auto_build/output
cp ./safeg/safeg.elf ./tools/auto_build/output


